import PropTypes from 'prop-types';
import React from 'react';
import classNames from 'classnames';
import { formatTime } from '../../utils';
var propTypes = {
  currentTime: PropTypes.number,
  duration: PropTypes.number,
  percentage: PropTypes.string,
  className: PropTypes.string
}; // Shows play progress

export default function PlayProgressBar(_ref) {
  var currentTime = _ref.currentTime,
      duration = _ref.duration,
      percentage = _ref.percentage,
      className = _ref.className;
  return React.createElement("div", {
    "data-current-time": formatTime(currentTime, duration),
    className: classNames('video-react-play-progress video-react-slider-bar', className),
    style: {
      width: percentage
    }
  }, React.createElement("span", {
    className: "video-react-control-text"
  }, "Progress: ".concat(percentage)));
}
PlayProgressBar.propTypes = propTypes;
PlayProgressBar.displayName = 'PlayProgressBar';