import PropTypes from 'prop-types';
import React from 'react';
import classNames from 'classnames';
import { formatTime } from '../../utils';
var propTypes = {
  player: PropTypes.object,
  className: PropTypes.string
};

function DurationDisplay(_ref) {
  var duration = _ref.player.duration,
      className = _ref.className;
  var formattedTime = formatTime(duration);
  return React.createElement("div", {
    className: classNames(className, 'video-react-duration video-react-time-control video-react-control')
  }, React.createElement("div", {
    className: "video-react-duration-display",
    "aria-live": "off"
  }, React.createElement("span", {
    className: "video-react-control-text"
  }, "Duration Time "), formattedTime));
}

DurationDisplay.propTypes = propTypes;
DurationDisplay.displayName = 'DurationDisplay';
export default DurationDisplay;