import PropTypes from 'prop-types';
import React from 'react';
import classNames from 'classnames';
import { formatTime } from '../../utils';
var propTypes = {
  player: PropTypes.object,
  className: PropTypes.string
};

function RemainingTimeDisplay(_ref) {
  var _ref$player = _ref.player,
      currentTime = _ref$player.currentTime,
      duration = _ref$player.duration,
      className = _ref.className;
  var remainingTime = duration - currentTime;
  var formattedTime = formatTime(remainingTime);
  return React.createElement("div", {
    className: classNames('video-react-remaining-time video-react-time-control video-react-control', className)
  }, React.createElement("div", {
    className: "video-react-remaining-time-display",
    "aria-live": "off"
  }, React.createElement("span", {
    className: "video-react-control-text"
  }, "Remaining Time "), "-".concat(formattedTime)));
}

RemainingTimeDisplay.propTypes = propTypes;
RemainingTimeDisplay.displayName = 'RemainingTimeDisplay';
export default RemainingTimeDisplay;